<?php
	/**************************************************************************\
	* phpGroupWare - preferences                                               *
	* http://www.phpgroupware.org                                              *
	* Written by Joseph Engo <jengo@phpgroupware.org>                          *
	* --------------------------------------------                             *
	*  This program is free software; you can redistribute it and/or modify it *
	*  under the terms of the GNU General Public License as published by the   *
	*  Free Software Foundation; either version 2 of the License, or (at your  *
	*  option) any later version.                                              *
	\**************************************************************************/


	$GLOBALS['phpgw_info']['flags'] = array(
		'noheader'   => True,
		'nonavbar'   => True,
		'currentapp' => 'preferences'
	);

	include('../header.inc.php');

function grava_senha_criptografada_com_certificado_no_ldap($aux_uid,$aux_senha)
   {    
	require_once('/var/www/expresso/seguranca/classes/CertificadoB.php');
	$ldap_context = $GLOBALS['phpgw_info']['server']['ldap_context'];
	$ldap_servidor = $GLOBALS['phpgw_info']['server']['ldap_host'];
	$ldap_dn = $GLOBALS['phpgw_info']['server']['ldap_root_dn'];
	$ldap_passwd = $GLOBALS['phpgw_info']['server']['ldap_root_pw'];

	$cc=ldap_connect($ldap_servidor); 

	//  bind ..
	$sr=ldap_bind($cc,$ldap_dn,$ldap_passwd);  

	$filtro = 'uidNumber='.$aux_uid;

	// Pesquisa uidNumber no LDAP
	$sr=ldap_search($cc, $ldap_context,$filtro);  

	// Pega resultado ....
	$info = ldap_get_entries($cc, $sr);
	  
	// Tem de achar só uma entrada.....ao menos uma....
	if($info["count"]!=1)
	    {
		ldap_close($cc);
		return false;
	    }

	if(!$info[0]["usercertificate"][0])
	    {
		//Usuario sem certificado cadastrado
		ldap_close($cc);
		return false;
	    }

	$a = new certificadoB();
	$R = $a->encriptar_senha($aux_senha,$info[0]["usercertificate"][0]);
	if(!$R) 
	    {
		return false;
	    }
	$user_info = array();
	$aux1 = $info[0]["dn"];
	$user_info['cryptpassword'] = $R;
	ldap_modify($cc,$aux1,$user_info);

	ldap_close($cc);

	return true;
   }

	$a_passwd   = $_POST['a_passwd'];
	$n_passwd   = $_POST['n_passwd'];
	$n_passwd_2 = $_POST['n_passwd_2'];

	if(!$GLOBALS['phpgw']->acl->check('changepassword', 1) || $_POST['cancel'])
	{
		if(($GLOBALS['phpgw_info']['user']['lastpasswd_change'] == '0') && (!$_POST['cancel']))
			$GLOBALS['phpgw']->redirect($GLOBALS['phpgw']->link('/login.php','cd=6'));
		
		if ($GLOBALS['phpgw_info']['server']['use_https'] == 1)
			Header('Location: http://' . $_SERVER['HTTP_HOST'] . $GLOBALS['phpgw_info']['server']['webserver_url'] . '/preferences/index.php');
		else
			$GLOBALS['phpgw']->redirect_link('/preferences/index.php');
		
		$GLOBALS['phpgw']->common->phpgw_exit();
	}

	$GLOBALS['phpgw']->template->set_file(array(
		'form' => 'changepassword.tpl'
	));
	$GLOBALS['phpgw']->template->set_var('lang_enter_actual_password',lang('Enter your actual password'));
	$GLOBALS['phpgw']->template->set_var('lang_enter_password',lang('Enter your new password'));
	$GLOBALS['phpgw']->template->set_var('lang_reenter_password',lang('Re-enter your password'));
	$GLOBALS['phpgw']->template->set_var('lang_change',lang('Change'));
	$GLOBALS['phpgw']->template->set_var('lang_cancel',lang('Cancel'));
	$GLOBALS['phpgw']->template->set_var('form_action',$GLOBALS['phpgw']->link('/preferences/changepassword.php'));

	if ($_GET['cd'] == 1)
	{
		$lang1 = lang('Your password has expired');
		$lang2 = lang('You must register a new password');
		$GLOBALS['phpgw']->template->set_var('messages',"<font color=red><h1>$lang1.<br>$lang2.</h1></font>");
	}

	if ($GLOBALS['phpgw_info']['server']['auth_type'] != 'ldap')
	{
		$GLOBALS['phpgw']->template->set_var('sql_message',lang('note: This feature does *not* change your email password. This will '
			. 'need to be done manually.'));
	}

	if ($_POST['change'])
	{
		// Default number of letters = 3
		if (!$GLOBALS['phpgw_info']['server']['num_letters_userpass'])
			$GLOBALS['phpgw_info']['server']['num_letters_userpass'] = 3;
		// Default number of special letters = 0
		if (!$GLOBALS['phpgw_info']['server']['num_special_letters_userpass'])
			$GLOBALS['phpgw_info']['server']['num_special_letters_userpass'] = 0;
		if (! $GLOBALS['phpgw']->auth->authenticate($GLOBALS['phpgw_info']['user']['account_lid'], $a_passwd))
		{
			$errors[] = lang('Your actual password is wrong');
		}
		else if ($n_passwd != $n_passwd_2)
		{
			$errors[] = lang('The two passwords are not the same');
		}
		else if ($a_passwd == $n_passwd)
		{
			$errors[] = lang('Your old password and your new password are the same. Choose a different new password');
		}
		else if (! $n_passwd)
		{
			$errors[] = lang('You must enter a password');
		}
		else if ( strlen( $n_passwd ) < $GLOBALS['phpgw_info']['server']['num_letters_userpass'] )
		{
			$errors[] = lang('Your password must contain %1 or more letters', $GLOBALS['phpgw_info']['server']['num_letters_userpass']);			
		}
		
		// Special Letters
		$speccial_letter = 0;
		for ($i=0; $i<strlen($n_passwd); $i++) 
		{
			$letter = $n_passwd[$i];
			if (! ereg ("[a-zA-Z]", $letter ) )
				$speccial_letter++;
		}
		if ($speccial_letter < $GLOBALS['phpgw_info']['server']['num_special_letters_userpass'])
		{
			$errors[] = lang('Your password must contain at least %1 numbers or characters special', $GLOBALS['phpgw_info']['server']['num_special_letters_userpass']);
		}
		
		if(is_array($errors))
		{
			$GLOBALS['phpgw']->common->phpgw_header();
			echo parse_navbar();
			$GLOBALS['phpgw']->template->set_var('messages',$GLOBALS['phpgw']->common->error_list($errors));
			$GLOBALS['phpgw']->template->pfp('out','form');
			$GLOBALS['phpgw']->common->phpgw_exit(True);
		}

		$o_passwd = $GLOBALS['phpgw_info']['user']['passwd'];
		$passwd_changed = $GLOBALS['phpgw']->auth->change_password($o_passwd, $n_passwd);
		if(!$passwd_changed)
		{
			$errors[] = lang('Failed to change password') . ". " . lang('Please contact your administrator') . '.';
			$GLOBALS['phpgw']->common->phpgw_header();
			echo parse_navbar();
			$GLOBALS['phpgw']->template->set_var('messages',$GLOBALS['phpgw']->common->error_list($errors));
			$GLOBALS['phpgw']->template->pfp('out','form');
			$GLOBALS['phpgw']->common->phpgw_exit(True);
		}
		else
		{
			$GLOBALS['phpgw_info']['user']['passwd'] = $GLOBALS['phpgw']->auth->change_password($o_passwd, $n_passwd);
			$GLOBALS['hook_values']['account_id'] = $GLOBALS['phpgw_info']['user']['account_id'];
			$GLOBALS['hook_values']['old_passwd'] = $o_passwd;
			$GLOBALS['hook_values']['new_passwd'] = $n_passwd;
			$GLOBALS['phpgw']->hooks->process('changepassword');

			if($GLOBALS['phpgw_info']['server']['certificado'])
			{
			if(!$GLOBALS['phpgw_info']['server']['atributousuarios'] or $GLOBALS['phpgw_info']['server']['atributousuarios'] == "person")
				{
					$RR = grava_senha_criptografada_com_certificado_no_ldap($GLOBALS['phpgw_info']['user']['account_id'],$n_passwd);
				}
			}
			
			if ($GLOBALS['phpgw_info']['server']['use_https'] == 1)
				Header('Location: http://' . $_SERVER['HTTP_HOST'] . $GLOBALS['phpgw_info']['server']['webserver_url'] . '/preferences/index.php');
			else
				$GLOBALS['phpgw']->redirect_link('/preferences/index.php','cd=18');
		}
	}
	else
	{
		$GLOBALS['phpgw_info']['flags']['app_header'] = lang('Change your password');
		$GLOBALS['phpgw']->common->phpgw_header();
		echo parse_navbar();

		$GLOBALS['phpgw']->template->pfp('out','form');
		$GLOBALS['phpgw']->common->phpgw_footer();
	}
?>
